Index: uspace/lib/device/include/hr.h
===================================================================
--- uspace/lib/device/include/hr.h	(revision 6784abcc49550b0cd5dbc158b309eccd974ef3d8)
+++ uspace/lib/device/include/hr.h	(revision 37a9c1e3083eac96370742d31a43475ce5727b1d)
@@ -109,5 +109,5 @@
 	size_t bsize;
 	hr_vol_status_t status;
-	uint8_t RLQ;
+	uint8_t layout;
 } hr_vol_info_t;
 
Index: uspace/lib/device/src/hr.c
===================================================================
--- uspace/lib/device/src/hr.c	(revision 6784abcc49550b0cd5dbc158b309eccd974ef3d8)
+++ uspace/lib/device/src/hr.c	(revision 37a9c1e3083eac96370742d31a43475ce5727b1d)
@@ -134,5 +134,5 @@
 	if (vol_info->level == HR_LVL_4 || vol_info->level == HR_LVL_5) {
 		printf("layout: %s\n",
-		    hr_get_layout_str(vol_info->level, vol_info->RLQ));
+		    hr_get_layout_str(vol_info->level, vol_info->layout));
 	}
 	if (vol_info->level == HR_LVL_0 || vol_info->level == HR_LVL_4) {
@@ -163,7 +163,7 @@
 		}
 		if (vol_info->level == HR_LVL_4) {
-			if ((i == 0 && vol_info->RLQ == HR_RLQ_RAID4_0) ||
+			if ((i == 0 && vol_info->layout == HR_RLQ_RAID4_0) ||
 			    (i == vol_info->extent_no - 1 &&
-			    vol_info->RLQ == HR_RLQ_RAID4_N))
+			    vol_info->layout == HR_RLQ_RAID4_N))
 				printf("          P   %s    %zu       %s\n", hr_get_ext_status_msg(ext->status), i, devname);
 			else
@@ -350,9 +350,9 @@
 }
 
-const char *hr_get_layout_str(hr_level_t level, uint8_t RLQ)
+const char *hr_get_layout_str(hr_level_t level, uint8_t layout)
 {
 	switch (level) {
 	case HR_LVL_4:
-		switch (RLQ) {
+		switch (layout) {
 		case HR_RLQ_RAID4_0:
 			return "RAID-4 Non-Rotating Parity 0";
@@ -363,5 +363,5 @@
 		}
 	case HR_LVL_5:
-		switch (RLQ) {
+		switch (layout) {
 		case HR_RLQ_RAID5_0R:
 			return "RAID-5 Rotating Parity 0 with Data Restart";
Index: uspace/srv/bd/hr/hr.c
===================================================================
--- uspace/srv/bd/hr/hr.c	(revision 6784abcc49550b0cd5dbc158b309eccd974ef3d8)
+++ uspace/srv/bd/hr/hr.c	(revision 37a9c1e3083eac96370742d31a43475ce5727b1d)
@@ -189,5 +189,5 @@
 	case HR_LVL_1:
 		if (!assemble)
-			new_volume->RLQ = 0x00; /* XXX: yet unused */
+			new_volume->layout = 0x00; /* XXX: yet unused */
 		new_volume->hr_ops.create = hr_raid1_create;
 		new_volume->hr_ops.init = hr_raid1_init;
@@ -197,5 +197,5 @@
 	case HR_LVL_0:
 		if (!assemble)
-			new_volume->RLQ = 0x00;
+			new_volume->layout = 0x00;
 		new_volume->hr_ops.create = hr_raid0_create;
 		new_volume->hr_ops.init = hr_raid0_init;
@@ -204,5 +204,5 @@
 	case HR_LVL_4:
 		if (!assemble)
-			new_volume->RLQ = HR_RLQ_RAID4_N;
+			new_volume->layout = HR_RLQ_RAID4_N;
 		new_volume->hr_ops.create = hr_raid5_create;
 		new_volume->hr_ops.init = hr_raid5_init;
@@ -212,5 +212,5 @@
 	case HR_LVL_5:
 		if (!assemble)
-			new_volume->RLQ = HR_RLQ_RAID5_NR;
+			new_volume->layout = HR_RLQ_RAID5_NR;
 		new_volume->hr_ops.create = hr_raid5_create;
 		new_volume->hr_ops.init = hr_raid5_init;
@@ -373,5 +373,5 @@
 		info.bsize = vol->bsize;
 		info.status = vol->status;
-		info.RLQ = vol->RLQ;
+		info.layout = vol->layout;
 
 		if (!async_data_read_receive(&call, &size)) {
Index: uspace/srv/bd/hr/raid5.c
===================================================================
--- uspace/srv/bd/hr/raid5.c	(revision 6784abcc49550b0cd5dbc158b309eccd974ef3d8)
+++ uspace/srv/bd/hr/raid5.c	(revision 37a9c1e3083eac96370742d31a43475ce5727b1d)
@@ -533,5 +533,5 @@
 		return rc;
 
-	uint8_t RLQ = vol->RLQ;
+	uint8_t layout = vol->layout;
 	hr_level_t level = vol->level;
 
@@ -541,12 +541,12 @@
 	/* parity extent */
 	uint64_t p_extent;
-	if (level == HR_LVL_4 && RLQ == HR_RLQ_RAID4_0) {
+	if (level == HR_LVL_4 && layout == HR_RLQ_RAID4_0) {
 		p_extent = 0;
-	} else if (level == HR_LVL_4 && RLQ == HR_RLQ_RAID4_N) {
+	} else if (level == HR_LVL_4 && layout == HR_RLQ_RAID4_N) {
 		p_extent = vol->extent_no - 1;
-	} else if (level == HR_LVL_5 && RLQ == HR_RLQ_RAID5_0R) {
+	} else if (level == HR_LVL_5 && layout == HR_RLQ_RAID5_0R) {
 		p_extent = (stripe / (vol->extent_no - 1)) % vol->extent_no;
 	} else if (level == HR_LVL_5 &&
-	    (RLQ == HR_RLQ_RAID5_NR || RLQ == HR_RLQ_RAID5_NC)) {
+	    (layout == HR_RLQ_RAID5_NR || layout == HR_RLQ_RAID5_NC)) {
 		p_extent = (vol->extent_no - 1) -
 		    (stripe / (vol->extent_no - 1)) % vol->extent_no;
@@ -556,15 +556,15 @@
 
 	uint64_t extent;
-	if (level == HR_LVL_4 && RLQ == HR_RLQ_RAID4_0) {
+	if (level == HR_LVL_4 && layout == HR_RLQ_RAID4_0) {
 		extent = (stripe % (vol->extent_no - 1)) + 1;
-	} else if (level == HR_LVL_4 && RLQ == HR_RLQ_RAID4_N) {
+	} else if (level == HR_LVL_4 && layout == HR_RLQ_RAID4_N) {
 		extent = stripe % (vol->extent_no - 1);
 	} else if (level == HR_LVL_5 &&
-	    (RLQ == HR_RLQ_RAID5_0R || RLQ == HR_RLQ_RAID5_NR)) {
+	    (layout == HR_RLQ_RAID5_0R || layout == HR_RLQ_RAID5_NR)) {
 		if ((stripe % (vol->extent_no - 1)) < p_extent)
 			extent = stripe % (vol->extent_no - 1);
 		else
 			extent = (stripe % (vol->extent_no - 1)) + 1;
-	} else if (level == HR_LVL_5 && RLQ == HR_RLQ_RAID5_NC) {
+	} else if (level == HR_LVL_5 && layout == HR_RLQ_RAID5_NC) {
 		extent = ((stripe % (vol->extent_no - 1)) + p_extent + 1) % vol->extent_no;
 	} else {
@@ -654,23 +654,23 @@
 		ext_stripe = stripe / (vol->extent_no - 1); /* stripe level */
 
-		if (level == HR_LVL_5 && RLQ == HR_RLQ_RAID5_0R) {
+		if (level == HR_LVL_5 && layout == HR_RLQ_RAID5_0R) {
 			p_extent = (stripe / (vol->extent_no - 1)) % vol->extent_no;
 		} else if (level == HR_LVL_5 &&
-		    (RLQ == HR_RLQ_RAID5_NR || RLQ == HR_RLQ_RAID5_NC)) {
+		    (layout == HR_RLQ_RAID5_NR || layout == HR_RLQ_RAID5_NC)) {
 			p_extent = (vol->extent_no - 1) -
 			    (stripe / (vol->extent_no - 1)) % vol->extent_no;
 		}
 
-		if (level == HR_LVL_4 && RLQ == HR_RLQ_RAID4_0) {
+		if (level == HR_LVL_4 && layout == HR_RLQ_RAID4_0) {
 			extent = (stripe % (vol->extent_no - 1)) + 1;
-		} else if (level == HR_LVL_4 && RLQ == HR_RLQ_RAID4_N) {
+		} else if (level == HR_LVL_4 && layout == HR_RLQ_RAID4_N) {
 			extent = stripe % (vol->extent_no - 1);
 		} else if (level == HR_LVL_5 &&
-		    (RLQ == HR_RLQ_RAID5_0R || RLQ == HR_RLQ_RAID5_NR)) {
+		    (layout == HR_RLQ_RAID5_0R || layout == HR_RLQ_RAID5_NR)) {
 			if ((stripe % (vol->extent_no - 1)) < p_extent)
 				extent = stripe % (vol->extent_no - 1);
 			else
 				extent = (stripe % (vol->extent_no - 1)) + 1;
-		} else if (level == HR_LVL_5 && RLQ == HR_RLQ_RAID5_NC) {
+		} else if (level == HR_LVL_5 && layout == HR_RLQ_RAID5_NC) {
 			extent = ((stripe % (vol->extent_no - 1)) + p_extent + 1) % vol->extent_no;
 		}
Index: uspace/srv/bd/hr/superblock.c
===================================================================
--- uspace/srv/bd/hr/superblock.c	(revision 6784abcc49550b0cd5dbc158b309eccd974ef3d8)
+++ uspace/srv/bd/hr/superblock.c	(revision 37a9c1e3083eac96370742d31a43475ce5727b1d)
@@ -157,5 +157,5 @@
 	/* index filled separately for each extent */
 	metadata->level = host2uint32_t_le(vol->level);
-	metadata->layout = host2uint32_t_le(vol->RLQ);
+	metadata->layout = host2uint32_t_le(vol->layout);
 	metadata->strip_size = host2uint32_t_le(vol->strip_size);
 	metadata->nblocks = host2uint64_t_le(vol->nblocks);
@@ -237,5 +237,5 @@
 	/* TODO: handle version */
 	vol->level = uint32_t_le2host(metadata->level);
-	vol->RLQ = (uint8_t)uint32_t_le2host(metadata->layout);
+	vol->layout = (uint8_t)uint32_t_le2host(metadata->layout);
 	vol->strip_size = uint32_t_le2host(metadata->strip_size);
 	vol->nblocks = uint64_t_le2host(metadata->nblocks);
Index: uspace/srv/bd/hr/var.h
===================================================================
--- uspace/srv/bd/hr/var.h	(revision 6784abcc49550b0cd5dbc158b309eccd974ef3d8)
+++ uspace/srv/bd/hr/var.h	(revision 37a9c1e3083eac96370742d31a43475ce5727b1d)
@@ -85,5 +85,5 @@
 	hr_vol_status_t status;
 	hr_level_t level;
-	uint8_t RLQ; /* RAID Level Qualifier */
+	uint8_t layout; /* RAID Level Qualifier */
 	char devname[HR_DEVNAME_LEN];
 } hr_volume_t;