Index: uspace/lib/block/block.c
===================================================================
--- uspace/lib/block/block.c	(revision b5abaf7c8551d1f27dee4024aa0f8824ee2e9317)
+++ uspace/lib/block/block.c	(revision 38d150e6238ab44c861f6486e46454e07caeb0f0)
@@ -49,5 +49,5 @@
 #include <macros.h>
 #include <mem.h>
-#include <malloc.h>
+#include <stdlib.h>
 #include <stdio.h>
 #include <stacktrace.h>
Index: uspace/lib/c/arch/ia64/src/tls.c
===================================================================
--- uspace/lib/c/arch/ia64/src/tls.c	(revision b5abaf7c8551d1f27dee4024aa0f8824ee2e9317)
+++ uspace/lib/c/arch/ia64/src/tls.c	(revision 38d150e6238ab44c861f6486e46454e07caeb0f0)
@@ -36,5 +36,4 @@
 
 #include <tls.h>
-#include <malloc.h>
 
 tcb_t *tls_alloc_arch(void **data, size_t size)
Index: uspace/lib/c/generic/adt/hash_table.c
===================================================================
--- uspace/lib/c/generic/adt/hash_table.c	(revision b5abaf7c8551d1f27dee4024aa0f8824ee2e9317)
+++ uspace/lib/c/generic/adt/hash_table.c	(revision 38d150e6238ab44c861f6486e46454e07caeb0f0)
@@ -51,6 +51,6 @@
 #include <adt/hash_table.h>
 #include <adt/list.h>
-#include <malloc.h>
 #include <assert.h>
+#include <stdlib.h>
 #include <str.h>
 
Index: uspace/lib/c/generic/as.c
===================================================================
--- uspace/lib/c/generic/as.c	(revision b5abaf7c8551d1f27dee4024aa0f8824ee2e9317)
+++ uspace/lib/c/generic/as.c	(revision 38d150e6238ab44c861f6486e46454e07caeb0f0)
@@ -40,5 +40,4 @@
 #include <stdint.h>
 #include <bitops.h>
-#include <malloc.h>
 #include "private/libc.h"
 
Index: uspace/lib/c/generic/async.c
===================================================================
--- uspace/lib/c/generic/async.c	(revision b5abaf7c8551d1f27dee4024aa0f8824ee2e9317)
+++ uspace/lib/c/generic/async.c	(revision 38d150e6238ab44c861f6486e46454e07caeb0f0)
@@ -113,5 +113,5 @@
 #include <libarch/barrier.h>
 #include <stdbool.h>
-#include <malloc.h>
+#include <stdlib.h>
 #include <mem.h>
 #include <stdlib.h>
Index: uspace/lib/c/generic/clipboard.c
===================================================================
--- uspace/lib/c/generic/clipboard.c	(revision b5abaf7c8551d1f27dee4024aa0f8824ee2e9317)
+++ uspace/lib/c/generic/clipboard.c	(revision 38d150e6238ab44c861f6486e46454e07caeb0f0)
@@ -45,5 +45,5 @@
 #include <ipc/services.h>
 #include <loc.h>
-#include <malloc.h>
+#include <stdlib.h>
 #include <str.h>
 
Index: uspace/lib/c/generic/device/hw_res.c
===================================================================
--- uspace/lib/c/generic/device/hw_res.c	(revision b5abaf7c8551d1f27dee4024aa0f8824ee2e9317)
+++ uspace/lib/c/generic/device/hw_res.c	(revision 38d150e6238ab44c861f6486e46454e07caeb0f0)
@@ -36,5 +36,5 @@
 #include <errno.h>
 #include <async.h>
-#include <malloc.h>
+#include <stdlib.h>
 
 int hw_res_get_resource_list(async_sess_t *sess,
Index: uspace/lib/c/generic/device/hw_res_parsed.c
===================================================================
--- uspace/lib/c/generic/device/hw_res_parsed.c	(revision b5abaf7c8551d1f27dee4024aa0f8824ee2e9317)
+++ uspace/lib/c/generic/device/hw_res_parsed.c	(revision 38d150e6238ab44c861f6486e46454e07caeb0f0)
@@ -34,7 +34,7 @@
 
 #include <device/hw_res_parsed.h>
-#include <malloc.h>
 #include <assert.h>
 #include <errno.h>
+#include <stdlib.h>
 
 static void hw_res_parse_add_dma_channel(hw_res_list_parsed_t *out,
Index: uspace/lib/c/generic/devman.c
===================================================================
--- uspace/lib/c/generic/devman.c	(revision b5abaf7c8551d1f27dee4024aa0f8824ee2e9317)
+++ uspace/lib/c/generic/devman.c	(revision 38d150e6238ab44c861f6486e46454e07caeb0f0)
@@ -44,5 +44,5 @@
 #include <async.h>
 #include <errno.h>
-#include <malloc.h>
+#include <stdlib.h>
 
 static FIBRIL_MUTEX_INITIALIZE(devman_driver_block_mutex);
Index: uspace/lib/c/generic/fibril.c
===================================================================
--- uspace/lib/c/generic/fibril.c	(revision b5abaf7c8551d1f27dee4024aa0f8824ee2e9317)
+++ uspace/lib/c/generic/fibril.c	(revision 38d150e6238ab44c861f6486e46454e07caeb0f0)
@@ -39,5 +39,5 @@
 #include <stack.h>
 #include <tls.h>
-#include <malloc.h>
+#include <stdlib.h>
 #include <abi/mm/as.h>
 #include <as.h>
Index: uspace/lib/c/generic/gsort.c
===================================================================
--- uspace/lib/c/generic/gsort.c	(revision b5abaf7c8551d1f27dee4024aa0f8824ee2e9317)
+++ uspace/lib/c/generic/gsort.c	(revision 38d150e6238ab44c861f6486e46454e07caeb0f0)
@@ -43,5 +43,5 @@
 #include <inttypes.h>
 #include <mem.h>
-#include <malloc.h>
+#include <stdlib.h>
 
 /** Immediate buffer size.
Index: uspace/lib/c/generic/inet/addr.c
===================================================================
--- uspace/lib/c/generic/inet/addr.c	(revision b5abaf7c8551d1f27dee4024aa0f8824ee2e9317)
+++ uspace/lib/c/generic/inet/addr.c	(revision 38d150e6238ab44c861f6486e46454e07caeb0f0)
@@ -39,5 +39,5 @@
 #include <stdio.h>
 #include <stddef.h>
-#include <malloc.h>
+#include <stdlib.h>
 #include <bitops.h>
 #include <inttypes.h>
Index: uspace/lib/c/generic/io/chargrid.c
===================================================================
--- uspace/lib/c/generic/io/chargrid.c	(revision b5abaf7c8551d1f27dee4024aa0f8824ee2e9317)
+++ uspace/lib/c/generic/io/chargrid.c	(revision 38d150e6238ab44c861f6486e46454e07caeb0f0)
@@ -34,5 +34,5 @@
 
 #include <io/style.h>
-#include <malloc.h>
+#include <stdlib.h>
 #include <assert.h>
 #include <stdbool.h>
Index: uspace/lib/c/generic/io/console.c
===================================================================
--- uspace/lib/c/generic/io/console.c	(revision b5abaf7c8551d1f27dee4024aa0f8824ee2e9317)
+++ uspace/lib/c/generic/io/console.c	(revision 38d150e6238ab44c861f6486e46454e07caeb0f0)
@@ -38,5 +38,5 @@
 #include <async.h>
 #include <errno.h>
-#include <malloc.h>
+#include <stdlib.h>
 #include <vfs/vfs_sess.h>
 #include <io/console.h>
Index: uspace/lib/c/generic/io/io.c
===================================================================
--- uspace/lib/c/generic/io/io.c	(revision b5abaf7c8551d1f27dee4024aa0f8824ee2e9317)
+++ uspace/lib/c/generic/io/io.c	(revision 38d150e6238ab44c861f6486e46454e07caeb0f0)
@@ -38,5 +38,5 @@
 #include <errno.h>
 #include <stdbool.h>
-#include <malloc.h>
+#include <stdlib.h>
 #include <async.h>
 #include <io/kio.h>
Index: uspace/lib/c/generic/ipc.c
===================================================================
--- uspace/lib/c/generic/ipc.c	(revision b5abaf7c8551d1f27dee4024aa0f8824ee2e9317)
+++ uspace/lib/c/generic/ipc.c	(revision 38d150e6238ab44c861f6486e46454e07caeb0f0)
@@ -43,5 +43,5 @@
 #include <ipc/ipc.h>
 #include <libc.h>
-#include <malloc.h>
+#include <stdlib.h>
 #include <errno.h>
 #include <adt/list.h>
Index: uspace/lib/c/generic/loc.c
===================================================================
--- uspace/lib/c/generic/loc.c	(revision b5abaf7c8551d1f27dee4024aa0f8824ee2e9317)
+++ uspace/lib/c/generic/loc.c	(revision 38d150e6238ab44c861f6486e46454e07caeb0f0)
@@ -36,5 +36,5 @@
 #include <async.h>
 #include <errno.h>
-#include <malloc.h>
+#include <stdlib.h>
 #include <stdbool.h>
 
Index: uspace/lib/c/generic/pio_trace.c
===================================================================
--- uspace/lib/c/generic/pio_trace.c	(revision b5abaf7c8551d1f27dee4024aa0f8824ee2e9317)
+++ uspace/lib/c/generic/pio_trace.c	(revision 38d150e6238ab44c861f6486e46454e07caeb0f0)
@@ -35,5 +35,5 @@
 #include <assert.h>
 #include <errno.h>
-#include <malloc.h>
+#include <stdlib.h>
 #include <adt/list.h>
 #include <fibril_synch.h>
Index: uspace/lib/c/generic/stats.c
===================================================================
--- uspace/lib/c/generic/stats.c	(revision b5abaf7c8551d1f27dee4024aa0f8824ee2e9317)
+++ uspace/lib/c/generic/stats.c	(revision 38d150e6238ab44c861f6486e46454e07caeb0f0)
@@ -39,5 +39,5 @@
 #include <stdio.h>
 #include <inttypes.h>
-#include <malloc.h>
+#include <stdlib.h>
 
 #define SYSINFO_STATS_MAX_PATH  64
Index: uspace/lib/c/generic/str.c
===================================================================
--- uspace/lib/c/generic/str.c	(revision b5abaf7c8551d1f27dee4024aa0f8824ee2e9317)
+++ uspace/lib/c/generic/str.c	(revision 38d150e6238ab44c861f6486e46454e07caeb0f0)
@@ -37,10 +37,9 @@
 
 #include <str.h>
+#include <stddef.h>
+#include <stdint.h>
 #include <stdlib.h>
-#include <stddef.h>
 #include <assert.h>
-#include <stdint.h>
 #include <ctype.h>
-#include <malloc.h>
 #include <errno.h>
 #include <align.h>
Index: uspace/lib/c/generic/sysinfo.c
===================================================================
--- uspace/lib/c/generic/sysinfo.c	(revision b5abaf7c8551d1f27dee4024aa0f8824ee2e9317)
+++ uspace/lib/c/generic/sysinfo.c	(revision 38d150e6238ab44c861f6486e46454e07caeb0f0)
@@ -37,5 +37,5 @@
 #include <str.h>
 #include <errno.h>
-#include <malloc.h>
+#include <stdlib.h>
 #include <stdbool.h>
 #include <stddef.h>
Index: uspace/lib/c/generic/task.c
===================================================================
--- uspace/lib/c/generic/task.c	(revision b5abaf7c8551d1f27dee4024aa0f8824ee2e9317)
+++ uspace/lib/c/generic/task.c	(revision 38d150e6238ab44c861f6486e46454e07caeb0f0)
@@ -45,5 +45,5 @@
 #include <errno.h>
 #include <ns.h>
-#include <malloc.h>
+#include <stdlib.h>
 #include <libc.h>
 #include "private/ns.h"
Index: uspace/lib/c/generic/time.c
===================================================================
--- uspace/lib/c/generic/time.c	(revision b5abaf7c8551d1f27dee4024aa0f8824ee2e9317)
+++ uspace/lib/c/generic/time.c	(revision 38d150e6238ab44c861f6486e46454e07caeb0f0)
@@ -51,5 +51,4 @@
 #include <loc.h>
 #include <device/clock_dev.h>
-#include <malloc.h>
 #include <thread.h>
 
Index: uspace/lib/c/generic/tls.c
===================================================================
--- uspace/lib/c/generic/tls.c	(revision b5abaf7c8551d1f27dee4024aa0f8824ee2e9317)
+++ uspace/lib/c/generic/tls.c	(revision 38d150e6238ab44c861f6486e46454e07caeb0f0)
@@ -39,5 +39,5 @@
 #include <align.h>
 #include <tls.h>
-#include <malloc.h>
+#include <stdlib.h>
 #include <str.h>
 
Index: uspace/lib/c/include/adt/fifo.h
===================================================================
--- uspace/lib/c/include/adt/fifo.h	(revision b5abaf7c8551d1f27dee4024aa0f8824ee2e9317)
+++ uspace/lib/c/include/adt/fifo.h	(revision 38d150e6238ab44c861f6486e46454e07caeb0f0)
@@ -46,5 +46,5 @@
 #define LIBC_FIFO_H_
 
-#include <malloc.h>
+#include <stdlib.h>
 
 typedef unsigned long fifo_count_t;
Index: uspace/lib/c/include/ieee80211/ieee80211.h
===================================================================
--- uspace/lib/c/include/ieee80211/ieee80211.h	(revision b5abaf7c8551d1f27dee4024aa0f8824ee2e9317)
+++ uspace/lib/c/include/ieee80211/ieee80211.h	(revision 38d150e6238ab44c861f6486e46454e07caeb0f0)
@@ -38,5 +38,4 @@
 #define LIBC_IEEE80211_H_
 
-#include <malloc.h>
 #include <adt/list.h>
 #include <nic/nic.h>
Index: uspace/lib/c/include/ipc/dev_iface.h
===================================================================
--- uspace/lib/c/include/ipc/dev_iface.h	(revision b5abaf7c8551d1f27dee4024aa0f8824ee2e9317)
+++ uspace/lib/c/include/ipc/dev_iface.h	(revision 38d150e6238ab44c861f6486e46454e07caeb0f0)
@@ -30,5 +30,5 @@
 #define LIBC_IPC_DEV_IFACE_H_
 
-#include <malloc.h>
+#include <stdlib.h>
 #include <types/common.h>
 
Index: uspace/lib/c/include/ipc/devman.h
===================================================================
--- uspace/lib/c/include/ipc/devman.h	(revision b5abaf7c8551d1f27dee4024aa0f8824ee2e9317)
+++ uspace/lib/c/include/ipc/devman.h	(revision 38d150e6238ab44c861f6486e46454e07caeb0f0)
@@ -36,6 +36,6 @@
 #include <ipc/common.h>
 #include <adt/list.h>
-#include <malloc.h>
 #include <mem.h>
+#include <stdlib.h>
 
 #define DEVMAN_NAME_MAXLEN  256
Index: uspace/lib/compress/gzip.c
===================================================================
--- uspace/lib/compress/gzip.c	(revision b5abaf7c8551d1f27dee4024aa0f8824ee2e9317)
+++ uspace/lib/compress/gzip.c	(revision 38d150e6238ab44c861f6486e46454e07caeb0f0)
@@ -31,6 +31,6 @@
 #include <errno.h>
 #include <mem.h>
-#include <malloc.h>
 #include <byteorder.h>
+#include <stdlib.h>
 #include "gzip.h"
 #include "inflate.h"
Index: uspace/lib/draw/codec/tga.gz.c
===================================================================
--- uspace/lib/draw/codec/tga.gz.c	(revision b5abaf7c8551d1f27dee4024aa0f8824ee2e9317)
+++ uspace/lib/draw/codec/tga.gz.c	(revision 38d150e6238ab44c861f6486e46454e07caeb0f0)
@@ -36,5 +36,5 @@
 #include <errno.h>
 #include <gzip.h>
-#include <malloc.h>
+#include <stdlib.h>
 #include "tga.gz.h"
 #include "tga.h"
Index: uspace/lib/draw/cursor.c
===================================================================
--- uspace/lib/draw/cursor.c	(revision b5abaf7c8551d1f27dee4024aa0f8824ee2e9317)
+++ uspace/lib/draw/cursor.c	(revision 38d150e6238ab44c861f6486e46454e07caeb0f0)
@@ -34,5 +34,5 @@
  */
 
-#include <malloc.h>
+#include <stdlib.h>
 
 #include "cursor.h"
Index: uspace/lib/draw/cursor/embedded.c
===================================================================
--- uspace/lib/draw/cursor/embedded.c	(revision b5abaf7c8551d1f27dee4024aa0f8824ee2e9317)
+++ uspace/lib/draw/cursor/embedded.c	(revision 38d150e6238ab44c861f6486e46454e07caeb0f0)
@@ -37,5 +37,5 @@
 #include <stddef.h>
 #include <stdint.h>
-#include <malloc.h>
+#include <stdlib.h>
 
 #include "../gfx/cursor-11x18.h"
Index: uspace/lib/draw/drawctx.c
===================================================================
--- uspace/lib/draw/drawctx.c	(revision b5abaf7c8551d1f27dee4024aa0f8824ee2e9317)
+++ uspace/lib/draw/drawctx.c	(revision 38d150e6238ab44c861f6486e46454e07caeb0f0)
@@ -36,5 +36,5 @@
 #include <assert.h>
 #include <adt/list.h>
-#include <malloc.h>
+#include <stdlib.h>
 
 #include "drawctx.h"
Index: uspace/lib/draw/font.c
===================================================================
--- uspace/lib/draw/font.c	(revision b5abaf7c8551d1f27dee4024aa0f8824ee2e9317)
+++ uspace/lib/draw/font.c	(revision 38d150e6238ab44c861f6486e46454e07caeb0f0)
@@ -35,6 +35,6 @@
  */
 
-#include <malloc.h>
 #include <errno.h>
+#include <stdlib.h>
 #include <str.h>
 
Index: uspace/lib/draw/font/bitmap_backend.c
===================================================================
--- uspace/lib/draw/font/bitmap_backend.c	(revision b5abaf7c8551d1f27dee4024aa0f8824ee2e9317)
+++ uspace/lib/draw/font/bitmap_backend.c	(revision 38d150e6238ab44c861f6486e46454e07caeb0f0)
@@ -35,6 +35,6 @@
  */
 
-#include <malloc.h>
 #include <errno.h>
+#include <stdlib.h>
 
 #include "../font.h"
Index: uspace/lib/draw/font/embedded.c
===================================================================
--- uspace/lib/draw/font/embedded.c	(revision b5abaf7c8551d1f27dee4024aa0f8824ee2e9317)
+++ uspace/lib/draw/font/embedded.c	(revision 38d150e6238ab44c861f6486e46454e07caeb0f0)
@@ -36,6 +36,6 @@
 
 #include <stdint.h>
-#include <malloc.h>
 #include <errno.h>
+#include <stdlib.h>
 
 #include "../gfx/font-8x16.h"
Index: uspace/lib/draw/font/pcf.c
===================================================================
--- uspace/lib/draw/font/pcf.c	(revision b5abaf7c8551d1f27dee4024aa0f8824ee2e9317)
+++ uspace/lib/draw/font/pcf.c	(revision 38d150e6238ab44c861f6486e46454e07caeb0f0)
@@ -36,5 +36,4 @@
 #include <stddef.h>
 #include <stdint.h>
-#include <malloc.h>
 #include <errno.h>
 #include <byteorder.h>
@@ -42,4 +41,5 @@
 #include <align.h>
 #include <offset.h>
+#include <stdlib.h>
 
 #include "pcf.h"
Index: uspace/lib/draw/path.c
===================================================================
--- uspace/lib/draw/path.c	(revision b5abaf7c8551d1f27dee4024aa0f8824ee2e9317)
+++ uspace/lib/draw/path.c	(revision 38d150e6238ab44c861f6486e46454e07caeb0f0)
@@ -35,5 +35,5 @@
 
 #include <assert.h>
-#include <malloc.h>
+#include <stdlib.h>
 
 #include "path.h"
Index: uspace/lib/draw/surface.c
===================================================================
--- uspace/lib/draw/surface.c	(revision b5abaf7c8551d1f27dee4024aa0f8824ee2e9317)
+++ uspace/lib/draw/surface.c	(revision 38d150e6238ab44c861f6486e46454e07caeb0f0)
@@ -35,8 +35,8 @@
  */
 
-#include <malloc.h>
 #include <mem.h>
 #include <as.h>
 #include <assert.h>
+#include <stdlib.h>
 #include "surface.h"
 
Index: uspace/lib/ext4/src/directory.c
===================================================================
--- uspace/lib/ext4/src/directory.c	(revision b5abaf7c8551d1f27dee4024aa0f8824ee2e9317)
+++ uspace/lib/ext4/src/directory.c	(revision 38d150e6238ab44c861f6486e46454e07caeb0f0)
@@ -38,6 +38,6 @@
 #include <byteorder.h>
 #include <errno.h>
-#include <malloc.h>
 #include <mem.h>
+#include <stdlib.h>
 #include <str.h>
 #include "ext4/directory.h"
Index: uspace/lib/ext4/src/extent.c
===================================================================
--- uspace/lib/ext4/src/extent.c	(revision b5abaf7c8551d1f27dee4024aa0f8824ee2e9317)
+++ uspace/lib/ext4/src/extent.c	(revision 38d150e6238ab44c861f6486e46454e07caeb0f0)
@@ -37,6 +37,6 @@
 #include <byteorder.h>
 #include <errno.h>
-#include <malloc.h>
 #include <mem.h>
+#include <stdlib.h>
 #include "ext4/balloc.h"
 #include "ext4/extent.h"
Index: uspace/lib/ext4/src/ops.c
===================================================================
--- uspace/lib/ext4/src/ops.c	(revision b5abaf7c8551d1f27dee4024aa0f8824ee2e9317)
+++ uspace/lib/ext4/src/ops.c	(revision 38d150e6238ab44c861f6486e46454e07caeb0f0)
@@ -42,6 +42,6 @@
 #include <libfs.h>
 #include <macros.h>
-#include <malloc.h>
 #include <mem.h>
+#include <stdlib.h>
 #include <str.h>
 #include <ipc/loc.h>
Index: uspace/lib/ext4/src/superblock.c
===================================================================
--- uspace/lib/ext4/src/superblock.c	(revision b5abaf7c8551d1f27dee4024aa0f8824ee2e9317)
+++ uspace/lib/ext4/src/superblock.c	(revision 38d150e6238ab44c861f6486e46454e07caeb0f0)
@@ -40,6 +40,6 @@
 #include <byteorder.h>
 #include <errno.h>
-#include <malloc.h>
 #include <mem.h>
+#include <stdlib.h>
 #include "ext4/superblock.h"
 
Index: uspace/lib/fmtutil/fmtutil.c
===================================================================
--- uspace/lib/fmtutil/fmtutil.c	(revision b5abaf7c8551d1f27dee4024aa0f8824ee2e9317)
+++ uspace/lib/fmtutil/fmtutil.c	(revision 38d150e6238ab44c861f6486e46454e07caeb0f0)
@@ -29,6 +29,6 @@
 #include <io/console.h>
 #include <errno.h>
-#include <malloc.h>
 #include <fmtutil.h>
+#include <stdlib.h>
 
 typedef struct {
Index: uspace/lib/graph/graph.c
===================================================================
--- uspace/lib/graph/graph.c	(revision b5abaf7c8551d1f27dee4024aa0f8824ee2e9317)
+++ uspace/lib/graph/graph.c	(revision 38d150e6238ab44c861f6486e46454e07caeb0f0)
@@ -38,6 +38,6 @@
 #include <inttypes.h>
 #include <stdio.h>
-#include <malloc.h>
 #include <as.h>
+#include <stdlib.h>
 #include "graph.h"
 
Index: uspace/lib/gui/button.c
===================================================================
--- uspace/lib/gui/button.c	(revision b5abaf7c8551d1f27dee4024aa0f8824ee2e9317)
+++ uspace/lib/gui/button.c	(revision 38d150e6238ab44c861f6486e46454e07caeb0f0)
@@ -35,5 +35,5 @@
 
 #include <str.h>
-#include <malloc.h>
+#include <stdlib.h>
 #include <drawctx.h>
 #include <surface.h>
Index: uspace/lib/gui/canvas.c
===================================================================
--- uspace/lib/gui/canvas.c	(revision b5abaf7c8551d1f27dee4024aa0f8824ee2e9317)
+++ uspace/lib/gui/canvas.c	(revision 38d150e6238ab44c861f6486e46454e07caeb0f0)
@@ -34,5 +34,5 @@
  */
 
-#include <malloc.h>
+#include <stdlib.h>
 #include <transform.h>
 #include <source.h>
Index: uspace/lib/gui/connection.c
===================================================================
--- uspace/lib/gui/connection.c	(revision b5abaf7c8551d1f27dee4024aa0f8824ee2e9317)
+++ uspace/lib/gui/connection.c	(revision 38d150e6238ab44c861f6486e46454e07caeb0f0)
@@ -35,5 +35,5 @@
 
 #include <mem.h>
-#include <malloc.h>
+#include <stdlib.h>
 #include <adt/list.h>
 #include <adt/prodcons.h>
Index: uspace/lib/gui/grid.c
===================================================================
--- uspace/lib/gui/grid.c	(revision b5abaf7c8551d1f27dee4024aa0f8824ee2e9317)
+++ uspace/lib/gui/grid.c	(revision 38d150e6238ab44c861f6486e46454e07caeb0f0)
@@ -37,5 +37,5 @@
 #include <assert.h>
 #include <mem.h>
-#include <malloc.h>
+#include <stdlib.h>
 #include <surface.h>
 #include "window.h"
Index: uspace/lib/gui/label.c
===================================================================
--- uspace/lib/gui/label.c	(revision b5abaf7c8551d1f27dee4024aa0f8824ee2e9317)
+++ uspace/lib/gui/label.c	(revision 38d150e6238ab44c861f6486e46454e07caeb0f0)
@@ -35,6 +35,6 @@
 
 #include <str.h>
-#include <malloc.h>
 #include <drawctx.h>
+#include <stdlib.h>
 #include <surface.h>
 #include <font/embedded.h>
Index: uspace/lib/gui/minimal.c
===================================================================
--- uspace/lib/gui/minimal.c	(revision b5abaf7c8551d1f27dee4024aa0f8824ee2e9317)
+++ uspace/lib/gui/minimal.c	(revision 38d150e6238ab44c861f6486e46454e07caeb0f0)
@@ -34,5 +34,5 @@
  */
 
-#include <malloc.h>
+#include <stdlib.h>
 #include <surface.h>
 
Index: uspace/lib/gui/terminal.c
===================================================================
--- uspace/lib/gui/terminal.c	(revision b5abaf7c8551d1f27dee4024aa0f8824ee2e9317)
+++ uspace/lib/gui/terminal.c	(revision 38d150e6238ab44c861f6486e46454e07caeb0f0)
@@ -35,5 +35,5 @@
 
 #include <errno.h>
-#include <malloc.h>
+#include <stdlib.h>
 #include <io/chargrid.h>
 #include <surface.h>
Index: uspace/lib/gui/window.c
===================================================================
--- uspace/lib/gui/window.c	(revision b5abaf7c8551d1f27dee4024aa0f8824ee2e9317)
+++ uspace/lib/gui/window.c	(revision 38d150e6238ab44c861f6486e46454e07caeb0f0)
@@ -40,5 +40,5 @@
 
 #include <as.h>
-#include <malloc.h>
+#include <stdlib.h>
 #include <str.h>
 
Index: uspace/lib/usbhid/src/hiddescriptor.c
===================================================================
--- uspace/lib/usbhid/src/hiddescriptor.c	(revision b5abaf7c8551d1f27dee4024aa0f8824ee2e9317)
+++ uspace/lib/usbhid/src/hiddescriptor.c	(revision 38d150e6238ab44c861f6486e46454e07caeb0f0)
@@ -36,8 +36,8 @@
 #include <errno.h>
 #include <stdio.h>
-#include <malloc.h>
 #include <mem.h>
 #include <usb/debug.h>
 #include <assert.h>
+#include <stdlib.h>
 
 
Index: uspace/lib/usbhid/src/hidparser.c
===================================================================
--- uspace/lib/usbhid/src/hidparser.c	(revision b5abaf7c8551d1f27dee4024aa0f8824ee2e9317)
+++ uspace/lib/usbhid/src/hidparser.c	(revision 38d150e6238ab44c861f6486e46454e07caeb0f0)
@@ -36,5 +36,5 @@
 #include <errno.h>
 #include <stdio.h>
-#include <malloc.h>
+#include <stdlib.h>
 #include <mem.h>
 #include <usb/debug.h>
Index: uspace/lib/usbhid/src/hidpath.c
===================================================================
--- uspace/lib/usbhid/src/hidpath.c	(revision b5abaf7c8551d1f27dee4024aa0f8824ee2e9317)
+++ uspace/lib/usbhid/src/hidpath.c	(revision 38d150e6238ab44c861f6486e46454e07caeb0f0)
@@ -36,6 +36,6 @@
 #include <errno.h>
 #include <stdio.h>
-#include <malloc.h>
 #include <mem.h>
+#include <stdlib.h>
 #include <usb/debug.h>
 #include <assert.h>